forked from fishercoder1534/Leetcode
-
Notifications
You must be signed in to change notification settings - Fork 0
/
_508.java
142 lines (124 loc) · 4.93 KB
/
_508.java
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
package com.fishercoder.solutions;
import com.fishercoder.common.classes.TreeNode;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
/**
* 508. Most Frequent Subtree Sum
*
* Given the root of a tree, you are asked to find the most frequent subtree sum.
* The subtree sum of a node is defined as the sum of all the node values formed by the subtree rooted at that node (including the node itself).
* So what is the most frequent subtree sum value? If there is a tie, return all the values with the highest frequency in any order.
Examples 1
Input:
5
/ \
2 -3
return [2, -3, 4], since all the values happen only once, return all of them in any order.
Examples 2
Input:
5
/ \
2 -5
return [2], since 2 happens twice, however -5 only occur once.
Note: You may assume the sum of values in any subtree is in the range of 32-bit signed integer.
*/
public class _508 {
public static class Solution1 {
//my purely original but verbose solution
public int[] findFrequentTreeSum(TreeNode root) {
if (root == null) {
return new int[]{};
}
Map<TreeNode, Integer> map = new HashMap();
postOrder(root, map);
Map<Integer, Integer> frequencyMap = new HashMap<>();
for (Map.Entry entry : map.entrySet()) {
frequencyMap.put((Integer) entry.getValue(), frequencyMap.getOrDefault(entry.getValue(), 0) + 1);
}
List<Map.Entry<Integer, Integer>> list = new LinkedList<>(frequencyMap.entrySet());
Collections.sort(list, (o1, o2) -> (o2.getValue()).compareTo(o1.getValue()));
int mostFrequency = list.get(0).getValue();
List<Integer> topFrequencyList = new ArrayList<>();
topFrequencyList.add(list.get(0).getKey());
int i = 1;
while (i < list.size() && list.get(i).getValue() == mostFrequency) {
topFrequencyList.add(list.get(i).getKey());
i++;
}
int[] result = new int[topFrequencyList.size()];
for (int j = 0; j < topFrequencyList.size(); j++) {
result[j] = topFrequencyList.get(j);
}
return result;
}
private int postOrder(TreeNode root, Map<TreeNode, Integer> map) {
int left = 0;
int right = 0;
if (root.left != null) {
left = postOrder(root.left, map);
}
if (root.right != null) {
right = postOrder(root.right, map);
}
if (root.left == null && root.right == null) {
map.put(root, root.val);
return root.val;
}
int sum = left + right + root.val;
map.put(root, sum);
return sum;
}
}
public static class Solution2 {
//my 2nd purely original but verbose solution
public int[] findFrequentTreeSum(TreeNode root) {
Map<Integer, Integer> map = new HashMap<>();
dfs(root, map);
List<Map.Entry<Integer, Integer>> entryList = new ArrayList<>(map.entrySet());
Collections.sort(entryList, (a, b) -> b.getValue() - a.getValue());
List<Integer> list = new ArrayList<>();
for (int i = 0; i < entryList.size(); i++) {
if (list.size() == 0) {
list.add(entryList.get(i).getKey());
} else {
if (map.get(list.get(0)) == entryList.get(i).getValue()) {
list.add(entryList.get(i).getKey());
} else {
break;
}
}
}
int[] result = new int[list.size()];
for (int i = 0; i < list.size(); i++) {
result[i] = list.get(i);
}
return result;
}
private int dfs(TreeNode root, Map<Integer, Integer> map) {
if (root == null) {
return 0;
}
if (root.left == null && root.right == null) {
map.put(root.val, map.getOrDefault(root.val, 0) + 1);
return root.val;
}
int leftVal = 0;
if (root.left != null) {
leftVal = dfs(root.left, map);
}
int rightVal = 0;
if (root.right != null) {
rightVal = dfs(root.right, map);
}
int val = leftVal + rightVal + root.val;
map.put(val, map.getOrDefault(val, 0) + 1);
return val;
}
}
//a more concise and space-efficient solution: https://discuss.leetcode.com/topic/77775/verbose-java-solution-postorder-traverse-hashmap-18ms
//the key difference between the above post and my original solution is that it's using Frequency as the key of the HashMap
}